osg::NodeVisitor Class Reference

`#include <NodeVisitor>`

Inheritance diagram for osg::NodeVisitor:

## Classes

class | DatabaseRequestHandler
class | ImageRequestHandler

## Public Types

enum | TraversalMode { TRAVERSE_NONE , TRAVERSE_PARENTS , TRAVERSE_ALL_CHILDREN , TRAVERSE_ACTIVE_CHILDREN }
enum | VisitorType { NODE_VISITOR = 0 , UPDATE_VISITOR , EVENT_VISITOR , COLLECT_OCCLUDER_VISITOR , CULL_VISITOR , INTERSECTION_VISITOR }
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| NodeVisitor (TraversalMode tm=TRAVERSE_NONE)
| NodeVisitor (VisitorType type, TraversalMode tm=TRAVERSE_NONE)
| NodeVisitor (const NodeVisitor &nv, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual | ~NodeVisitor ()
| META_Object (osg, NodeVisitor) virtual NodeVisitor *asNodeVisitor()
virtual const NodeVisitor * | asNodeVisitor () const
virtual osgUtil::UpdateVisitor * | asUpdateVisitor ()
virtual const osgUtil::UpdateVisitor * | asUpdateVisitor () const
virtual osgUtil::CullVisitor * | asCullVisitor ()
virtual const osgUtil::CullVisitor * | asCullVisitor () const
virtual osgGA::EventVisitor * | asEventVisitor ()
virtual const osgGA::EventVisitor * | asEventVisitor () const
virtual osgUtil::IntersectionVisitor * | asIntersectionVisitor ()
virtual const osgUtil::IntersectionVisitor * | asIntersectionVisitor () const
virtual osg::CullStack * | asCullStack ()
virtual const osg::CullStack * | asCullStack () const
virtual void | reset ()
void | setVisitorType (VisitorType type)
VisitorType | getVisitorType () const
void | setTraversalNumber (unsigned int fn)
unsigned int | getTraversalNumber () const
void | setFrameStamp (FrameStamp *fs)
const FrameStamp * | getFrameStamp () const
void | setTraversalMask (Node::NodeMask mask)
Node::NodeMask | getTraversalMask () const
void | setNodeMaskOverride (Node::NodeMask mask)
Node::NodeMask | getNodeMaskOverride () const
bool | validNodeMask (const osg::Node &node) const
void | setTraversalMode (TraversalMode mode)
TraversalMode | getTraversalMode () const
void | setValueMap (ValueMap *ps)
ValueMap * | getValueMap ()
const ValueMap * | getValueMap () const
ValueMap * | getOrCreateValueMap ()
void | setValueStack (ValueStack *ps)
ValueStack * | getValueStack ()
const ValueStack * | getValueStack () const
ValueStack * | getOrCreateValueStack ()
void | traverse (Node &node)
void | pushOntoNodePath (Node *node)
void | popFromNodePath ()
NodePath & | getNodePath ()
const NodePath & | getNodePath () const
virtual osg::Vec3 | getEyePoint () const
virtual osg::Vec3 | getViewPoint () const
virtual float | getDistanceToEyePoint (const Vec3 &, bool) const
virtual float | getDistanceFromEyePoint (const Vec3 &, bool) const
virtual float | getDistanceToViewPoint (const Vec3 &, bool) const
virtual void | apply (Drawable &drawable)
virtual void | apply (Geometry &geometry)
virtual void | apply (Node &node)
virtual void | apply (Geode &node)
virtual void | apply (Billboard &node)
virtual void | apply (Group &node)
virtual void | apply (ProxyNode &node)
virtual void | apply (Projection &node)
virtual void | apply (CoordinateSystemNode &node)
virtual void | apply (ClipNode &node)
virtual void | apply (TexGenNode &node)
virtual void | apply (LightSource &node)
virtual void | apply (Transform &node)
virtual void | apply (Camera &node)
virtual void | apply (CameraView &node)
virtual void | apply (MatrixTransform &node)
virtual void | apply (PositionAttitudeTransform &node)
virtual void | apply (AutoTransform &node)
virtual void | apply (Switch &node)
virtual void | apply (Sequence &node)
virtual void | apply (LOD &node)
virtual void | apply (PagedLOD &node)
virtual void | apply (ClearNode &node)
virtual void | apply (OccluderNode &node)
virtual void | apply (OcclusionQueryNode &node)
void | setDatabaseRequestHandler (DatabaseRequestHandler *handler)
DatabaseRequestHandler * | getDatabaseRequestHandler ()
const DatabaseRequestHandler * | getDatabaseRequestHandler () const
void | setImageRequestHandler (ImageRequestHandler *handler)
ImageRequestHandler * | getImageRequestHandler ()
const ImageRequestHandler * | getImageRequestHandler () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Attributes

VisitorType | _visitorType
unsigned int | _traversalNumber
ref_ptr< FrameStamp > | _frameStamp
TraversalMode | _traversalMode
Node::NodeMask | _traversalMask
Node::NodeMask | _nodeMaskOverride
NodePath | _nodePath
ref_ptr< DatabaseRequestHandler > | _databaseRequestHandler
ref_ptr< ImageRequestHandler > | _imageRequestHandler
osg::ref_ptr< ValueMap > | _valueMap
osg::ref_ptr< ValueStack > | _valueStack
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Detailed Description

Visitor for type safe operations on osg::Nodes. Based on GOF's Visitor pattern. The NodeVisitor is useful for developing type safe operations to nodes in the scene graph (as per Visitor pattern), and adds to this support for optional scene graph traversal to allow operations to be applied to whole scenes at once. The Visitor pattern uses a technique of double dispatch as a mechanism to call the appropriate apply(..) method of the NodeVisitor. To use this feature one must use the Node::accept(NodeVisitor) which is extended in each Node subclass, rather than the NodeVisitor apply directly. So use root->accept(myVisitor); instead of myVisitor.apply(*root). The later method will bypass the double dispatch and the appropriate NodeVisitor::apply(..) method will not be called.

## Member Enumeration Documentation

## TraversalMode

enum osg::NodeVisitor::TraversalMode

Enumerator
TRAVERSE_NONE |
TRAVERSE_PARENTS |
TRAVERSE_ALL_CHILDREN |
TRAVERSE_ACTIVE_CHILDREN |

## VisitorType

enum osg::NodeVisitor::VisitorType

Enumerator
NODE_VISITOR |
UPDATE_VISITOR |
EVENT_VISITOR |
COLLECT_OCCLUDER_VISITOR |
CULL_VISITOR |
INTERSECTION_VISITOR |

## Constructor & Destructor Documentation

## NodeVisitor() [1/3]

osg::NodeVisitor::NodeVisitor | ( | TraversalMode | tm = TRAVERSE_NONE | ) |

References TRAVERSE_NONE.

Referenced by asNodeVisitor(), osgUtil::BaseOptimizerVisitor::BaseOptimizerVisitor(), osg::ConfigureBufferObjectsVisitor::ConfigureBufferObjectsVisitor(), osgUtil::DrawElementTypeSimplifierVisitor::DrawElementTypeSimplifierVisitor(), osgAnimation::RigGeometry::FindNearestParentSkeleton::FindNearestParentSkeleton(), META_Object(), and NodeVisitor().

## NodeVisitor() [2/3]

osg::NodeVisitor::NodeVisitor | ( | VisitorType | type,
|  | TraversalMode | tm = TRAVERSE_NONE )

References TRAVERSE_NONE.

## NodeVisitor() [3/3]

osg::NodeVisitor::NodeVisitor | ( | const NodeVisitor & | nv,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References NodeVisitor(), and osg::CopyOp::SHALLOW_COPY.

## ~NodeVisitor()

virtual osg::NodeVisitor::~NodeVisitor | ( |  | ) |

virtual

## Member Function Documentation

## apply() [1/25]

virtual void osg::NodeVisitor::apply | ( | AutoTransform & | node | ) |

virtual

## apply() [2/25]

virtual void osg::NodeVisitor::apply | ( | Billboard & | node | ) |

virtual

Reimplemented in osgGA::EventVisitor, osgUtil::CullVisitor, osgUtil::IntersectionVisitor, osgUtil::IntersectVisitor, osgUtil::Optimizer::FlattenBillboardVisitor, osgUtil::Optimizer::FlattenStaticTransformsDuplicatingSharedSubgraphsVisitor, osgUtil::Optimizer::FlattenStaticTransformsVisitor, osgUtil::Optimizer::MergeGeometryVisitor, and osgUtil::UpdateVisitor.

## apply() [3/25]

virtual void osg::NodeVisitor::apply | ( | Camera & | node | ) |

virtual

Reimplemented in osgUtil::CullVisitor, osgUtil::IntersectionVisitor, and osgUtil::PickVisitor.

## apply() [4/25]

virtual void osg::NodeVisitor::apply | ( | CameraView & | node | ) |

virtual

## apply() [5/25]

virtual void osg::NodeVisitor::apply | ( | ClearNode & | node | ) |

virtual

Reimplemented in osgUtil::CullVisitor.

## apply() [6/25]

virtual void osg::NodeVisitor::apply | ( | ClipNode & | node | ) |

virtual

Reimplemented in osgUtil::CullVisitor.

## apply() [7/25]

virtual void osg::NodeVisitor::apply | ( | CoordinateSystemNode & | node | ) |

virtual

## apply() [8/25]

virtual void osg::NodeVisitor::apply | ( | Drawable & | drawable | ) |

virtual

Reimplemented in osg::ComputeBoundsVisitor, osgGA::EventVisitor, osgUtil::CullVisitor, osgUtil::GLObjectsVisitor, osgUtil::IntersectionVisitor, osgUtil::IntersectVisitor, osgUtil::Optimizer::FlattenStaticTransformsVisitor, osgUtil::Optimizer::StaticObjectDetectionVisitor, osgUtil::Optimizer::TextureAtlasVisitor, osgUtil::StateToCompile, osgUtil::StatsVisitor, and osgUtil::UpdateVisitor.

Referenced by osgParticle::Emitter::accept(), osgParticle::ParticleEffect::accept(), osgParticle::ParticleProcessor::accept(), osgParticle::PrecipitationEffect::accept(), and osgParticle::Program::accept().

## apply() [9/25]

virtual void osg::NodeVisitor::apply | ( | Geode & | node | ) |

virtual

Reimplemented in osgAnimation::LinkVisitor, osgGA::EventVisitor, osgUtil::CullVisitor, osgUtil::IntersectionVisitor, osgUtil::IntersectVisitor, osgUtil::Optimizer::FlattenStaticTransformsDuplicatingSharedSubgraphsVisitor, osgUtil::Optimizer::SpatializeGroupsVisitor, osgUtil::StatsVisitor, and osgUtil::UpdateVisitor.

## apply() [10/25]

virtual void osg::NodeVisitor::apply | ( | Geometry & | geometry | ) |

virtual

Reimplemented in osg::ConfigureBufferObjectsVisitor, osg::KdTreeBuilder, osgUtil::DrawElementTypeSimplifierVisitor, osgUtil::GeometryCollector, osgUtil::Optimizer::BufferObjectVisitor, osgUtil::Optimizer::MakeFastGeometryVisitor, osgUtil::Optimizer::TessellateVisitor, osgUtil::Simplifier, osgUtil::SmoothingVisitor, osgUtil::TriStripVisitor, and osgUtil::VertexCacheMissVisitor.

## apply() [11/25]

virtual void osg::NodeVisitor::apply | ( | Group & | node | ) |

virtual

Reimplemented in osgGA::EventVisitor, osgSim::InsertImpostorsVisitor, osgUtil::CullVisitor, osgUtil::IntersectionVisitor, osgUtil::IntersectVisitor, osgUtil::Optimizer::FlattenStaticTransformsDuplicatingSharedSubgraphsVisitor, osgUtil::Optimizer::MergeGeodesVisitor, osgUtil::Optimizer::MergeGeometryVisitor, osgUtil::Optimizer::RemoveEmptyNodesVisitor, osgUtil::Optimizer::RemoveRedundantNodesVisitor, osgUtil::Optimizer::SpatializeGroupsVisitor, osgUtil::StatsVisitor, and osgUtil::UpdateVisitor.

## apply() [12/25]

virtual void osg::NodeVisitor::apply | ( | LightSource & | node | ) |

virtual

Reimplemented in osgGA::EventVisitor, osgUtil::CullVisitor, and osgUtil::UpdateVisitor.

## apply() [13/25]

virtual void osg::NodeVisitor::apply | ( | LOD & | node | ) |

virtual

Reimplemented in osg::CollectOccludersVisitor, osgGA::EventVisitor, osgSim::InsertImpostorsVisitor, osgUtil::CullVisitor, osgUtil::IntersectionVisitor, osgUtil::IntersectVisitor, osgUtil::Optimizer::CombineLODsVisitor, osgUtil::Optimizer::FlattenStaticTransformsDuplicatingSharedSubgraphsVisitor, osgUtil::StatsVisitor, and osgUtil::UpdateVisitor.

## apply() [14/25]

virtual void osg::NodeVisitor::apply | ( | MatrixTransform & | node | ) |

virtual

Reimplemented in osgUtil::Optimizer::CombineStaticTransformsVisitor.

## apply() [15/25]

virtual void osg::NodeVisitor::apply | ( | Node & | node | ) |

virtual

Reimplemented in osg::CollectOccludersVisitor, osgAnimation::BoneMapVisitor, osgAnimation::LinkVisitor, osgDB::SharedStateManager, osgGA::EventVisitor, osgSim::InsertImpostorsVisitor, osgUtil::CullVisitor, osgUtil::DisplayRequirementsVisitor, osgUtil::GLObjectsVisitor, osgUtil::IntersectionVisitor, osgUtil::IntersectVisitor, osgUtil::Optimizer::CopySharedSubgraphsVisitor, osgUtil::Optimizer::FlattenStaticTransformsVisitor, osgUtil::Optimizer::StateVisitor, osgUtil::Optimizer::StaticObjectDetectionVisitor, osgUtil::Optimizer::TextureAtlasVisitor, osgUtil::Optimizer::TextureVisitor, osgUtil::PrintVisitor, osgUtil::ShaderGenVisitor, osgUtil::StateToCompile, osgUtil::StatsVisitor, and osgUtil::UpdateVisitor.

## apply() [16/25]

virtual void osg::NodeVisitor::apply | ( | OccluderNode & | node | ) |

virtual

Reimplemented in osg::CollectOccludersVisitor, osgGA::EventVisitor, osgUtil::CullVisitor, and osgUtil::UpdateVisitor.

## apply() [17/25]

virtual void osg::NodeVisitor::apply | ( | OcclusionQueryNode & | node | ) |

virtual

Reimplemented in osgUtil::CullVisitor.

## apply() [18/25]

virtual void osg::NodeVisitor::apply | ( | PagedLOD & | node | ) |

virtual

Reimplemented in osgUtil::IntersectionVisitor, and osgUtil::Optimizer::FlattenStaticTransformsVisitor.

## apply() [19/25]

virtual void osg::NodeVisitor::apply | ( | PositionAttitudeTransform & | node | ) |

virtual

## apply() [20/25]

virtual void osg::NodeVisitor::apply | ( | Projection & | node | ) |

virtual

Reimplemented in osg::CollectOccludersVisitor, osgGA::EventVisitor, osgUtil::CullVisitor, osgUtil::IntersectionVisitor, osgUtil::PickVisitor, and osgUtil::UpdateVisitor.

## apply() [21/25]

virtual void osg::NodeVisitor::apply | ( | ProxyNode & | node | ) |

virtual

Reimplemented in osgUtil::Optimizer::FlattenStaticTransformsVisitor, and osgUtil::Optimizer::RemoveLoadedProxyNodesVisitor.

## apply() [22/25]

virtual void osg::NodeVisitor::apply | ( | Sequence & | node | ) |

virtual

## apply() [23/25]

virtual void osg::NodeVisitor::apply | ( | Switch & | node | ) |

virtual

Reimplemented in osg::CollectOccludersVisitor, osgGA::EventVisitor, osgUtil::CullVisitor, osgUtil::IntersectVisitor, osgUtil::StatsVisitor, and osgUtil::UpdateVisitor.

## apply() [24/25]

virtual void osg::NodeVisitor::apply | ( | TexGenNode & | node | ) |

virtual

Reimplemented in osgUtil::CullVisitor.

## apply() [25/25]

virtual void osg::NodeVisitor::apply | ( | Transform & | node | ) |

virtual

Reimplemented in osg::CollectOccludersVisitor, osg::ComputeBoundsVisitor, osgAnimation::BoneMapVisitor, osgAnimation::RigGeometry::FindNearestParentSkeleton, osgGA::EventVisitor, osgUtil::CullVisitor, osgUtil::IntersectionVisitor, osgUtil::IntersectVisitor, osgUtil::Optimizer::FlattenStaticTransformsDuplicatingSharedSubgraphsVisitor, osgUtil::Optimizer::FlattenStaticTransformsVisitor, osgUtil::Optimizer::RemoveRedundantNodesVisitor, osgUtil::StatsVisitor, and osgUtil::UpdateVisitor.

## asCullStack() [1/2]

virtual osg::CullStack * osg::NodeVisitor::asCullStack | ( |  | ) |

inline virtual

Convert 'this' into a osg::CullStack pointer if Object is a osg::CullStack, otherwise return 0. Equivalent to dynamic_cast<osg::CullStack*>(this).

Reimplemented in osgUtil::CullVisitor.

## asCullStack() [2/2]

virtual const osg::CullStack * osg::NodeVisitor::asCullStack | ( |  | ) | const

inline virtual

convert 'const this' into a const osg::CullStack pointer if Object is a osg::CullStack, otherwise return 0. Equivalent to dynamic_cast<const osg::CullStack*>(this).

Reimplemented in osgUtil::CullVisitor.

## asCullVisitor() [1/2]

virtual osgUtil::CullVisitor * osg::NodeVisitor::asCullVisitor | ( |  | ) |

inline virtual

Convert 'this' into a osgUtil::CullVisitor pointer if Object is a osgUtil::CullVisitor, otherwise return 0. Equivalent to dynamic_cast<osgUtil::CullVisitor*>(this).

## asCullVisitor() [2/2]

virtual const osgUtil::CullVisitor * osg::NodeVisitor::asCullVisitor | ( |  | ) | const

inline virtual

convert 'const this' into a const osgUtil::CullVisitor pointer if Object is a osgUtil::CullVisitor, otherwise return 0. Equivalent to dynamic_cast<const osgUtil::CullVisitor*>(this).

Reimplemented in osgUtil::CullVisitor.

## asEventVisitor() [1/2]

virtual osgGA::EventVisitor * osg::NodeVisitor::asEventVisitor | ( |  | ) |

inline virtual

Convert 'this' into a osgGA::EventVisitor pointer if Object is a osgGA::EventVisitor, otherwise return 0. Equivalent to dynamic_cast<osgGA::EventVisitor*>(this).

## asEventVisitor() [2/2]

virtual const osgGA::EventVisitor * osg::NodeVisitor::asEventVisitor | ( |  | ) | const

inline virtual

convert 'const this' into a const osgGA::EventVisitor pointer if Object is a osgGA::EventVisitor, otherwise return 0. Equivalent to dynamic_cast<const osgGA::EventVisitor*>(this).

Reimplemented in osgGA::EventVisitor.

## asIntersectionVisitor() [1/2]

virtual osgUtil::IntersectionVisitor * osg::NodeVisitor::asIntersectionVisitor | ( |  | ) |

inline virtual

Convert 'this' into a osgUtil::IntersectionVisitor pointer if Object is a IntersectionVisitor, otherwise return 0. Equivalent to dynamic_cast<osgUtil::IntersectionVisitor*>(this).

## asIntersectionVisitor() [2/2]

virtual const osgUtil::IntersectionVisitor * osg::NodeVisitor::asIntersectionVisitor | ( |  | ) | const

inline virtual

convert 'const this' into a const osgUtil::IntersectionVisitor pointer if Object is a IntersectionVisitor, otherwise return 0. Equivalent to dynamic_cast<const osgUtil::IntersectionVisitor*>(this).

Reimplemented in osgUtil::IntersectionVisitor.

## asNodeVisitor()

virtual const NodeVisitor * osg::NodeVisitor::asNodeVisitor | ( |  | ) | const

inline virtual

convert 'const this' into a const NodeVisitor pointer if Object is a NodeVisitor, otherwise return 0. Equivalent to dynamic_cast<const NodeVisitor*>(this).

Reimplemented from osg::Object.

References NodeVisitor().

Referenced by META_Object().

## asUpdateVisitor() [1/2]

virtual osgUtil::UpdateVisitor * osg::NodeVisitor::asUpdateVisitor | ( |  | ) |

inline virtual

Convert 'this' into a osgUtil::UpdateVisitor pointer if Object is a osgUtil::UpdateVisitor, otherwise return 0. Equivalent to dynamic_cast<osgUtil::UpdateVisitor*>(this).

## asUpdateVisitor() [2/2]

virtual const osgUtil::UpdateVisitor * osg::NodeVisitor::asUpdateVisitor | ( |  | ) | const

inline virtual

convert 'const this' into a const osgUtil::UpdateVisitor pointer if Object is a osgUtil::UpdateVisitor, otherwise return 0. Equivalent to dynamic_cast<const osgUtil::UpdateVisitor*>(this).

Reimplemented in osgUtil::UpdateVisitor.

## getDatabaseRequestHandler() [1/2]

DatabaseRequestHandler * osg::NodeVisitor::getDatabaseRequestHandler | ( |  | ) |

inline

Get the handler for database requests.

References _databaseRequestHandler.

## getDatabaseRequestHandler() [2/2]

const DatabaseRequestHandler * osg::NodeVisitor::getDatabaseRequestHandler | ( |  | ) | const

inline

Get the const handler for database requests.

References _databaseRequestHandler.

## getDistanceFromEyePoint()

virtual float osg::NodeVisitor::getDistanceFromEyePoint | ( | const Vec3 & | ,
|  | bool | ) const

inline virtual

Get the distance of a point from the eye point, distance value in the eye coordinate system. Note, not all NodeVisitor implement this method, it is mainly cull visitors which will implement. If the getDistanceFromEyePoint(pos) is not implemented than a default value of 0.0 is returned.

Reimplemented in osg::CollectOccludersVisitor, and osgUtil::CullVisitor.

## getDistanceToEyePoint()

virtual float osg::NodeVisitor::getDistanceToEyePoint | ( | const Vec3 & | ,
|  | bool | ) const

inline virtual

Get the distance from a point to the eye point, distance value in local coordinate system. Note, not all NodeVisitor implement this method, it is mainly cull visitors which will implement. If the getDistanceFromEyePoint(pos) is not implemented then a default value of 0.0 is returned.

Reimplemented in osg::CollectOccludersVisitor, osgUtil::CullVisitor, osgUtil::IntersectionVisitor, and osgUtil::IntersectVisitor.

## getDistanceToViewPoint()

virtual float osg::NodeVisitor::getDistanceToViewPoint | ( | const Vec3 & | ,
|  | bool | ) const

inline virtual

Get the distance from a point to the view point, distance value in local coordinate system. Note, not all NodeVisitor implement this method, it is mainly cull visitors which will implement. If the getDistanceToViewPoint(pos) is not implemented then a default value of 0.0 is returned.

Reimplemented in osg::CollectOccludersVisitor, and osgUtil::CullVisitor.

## getEyePoint()

virtual osg::Vec3 osg::NodeVisitor::getEyePoint | ( |  | ) | const

inline virtual

Get the eye point in local coordinates. Note, not all NodeVisitor implement this method, it is mainly cull visitors which will implement.

Reimplemented in osgUtil::CullVisitor, osgUtil::IntersectionVisitor, and osgUtil::IntersectVisitor.

Referenced by getViewPoint().

## getFrameStamp()

const FrameStamp * osg::NodeVisitor::getFrameStamp | ( |  | ) | const

inline

Get the FrameStamp that this traversal is associated with.

References _frameStamp.

## getImageRequestHandler() [1/2]

ImageRequestHandler * osg::NodeVisitor::getImageRequestHandler | ( |  | ) |

inline

Get the handler for image requests.

References _imageRequestHandler.

## getImageRequestHandler() [2/2]

const ImageRequestHandler * osg::NodeVisitor::getImageRequestHandler | ( |  | ) | const

inline

Get the const handler for image requests.

References _imageRequestHandler.

## getNodeMaskOverride()

Node::NodeMask osg::NodeVisitor::getNodeMaskOverride | ( |  | ) | const

inline

Get the NodeMaskOverride mask.

References _nodeMaskOverride.

Referenced by validNodeMask().

## getNodePath() [1/2]

NodePath & osg::NodeVisitor::getNodePath | ( |  | ) |

inline

Get the non const NodePath from the top most node applied down to the current Node being visited.

References _nodePath.

## getNodePath() [2/2]

const NodePath & osg::NodeVisitor::getNodePath | ( |  | ) | const

inline

Get the const NodePath from the top most node applied down to the current Node being visited.

References _nodePath.

## getOrCreateValueMap()

ValueMap * osg::NodeVisitor::getOrCreateValueMap | ( |  | ) |

inline

Get the ValueMap.

References _valueMap.

Referenced by osg::getOrCreateUserObjectOfType< NodeVisitor, ValueMap >().

## getOrCreateValueStack()

ValueStack * osg::NodeVisitor::getOrCreateValueStack | ( |  | ) |

inline

Get the ValueStack.

References _valueStack.

Referenced by osg::getOrCreateUserObjectOfType< NodeVisitor, ValueStack >(), osg::PushPopObject::PushPopObject(), and osg::PushPopValue::PushPopValue().

## getTraversalMask()

Node::NodeMask osg::NodeVisitor::getTraversalMask | ( |  | ) | const

inline

Get the TraversalMask.

References _traversalMask.

Referenced by validNodeMask().

## getTraversalMode()

TraversalMode osg::NodeVisitor::getTraversalMode | ( |  | ) | const

inline

Get the traversal mode.

References _traversalMode.

## getTraversalNumber()

unsigned int osg::NodeVisitor::getTraversalNumber | ( |  | ) | const

inline

Get the traversal number. Typically used to denote the frame count.

References _traversalNumber.

## getValueMap() [1/2]

ValueMap * osg::NodeVisitor::getValueMap | ( |  | ) |

inline

Get the ValueMap.

References _valueMap.

## getValueMap() [2/2]

const ValueMap * osg::NodeVisitor::getValueMap | ( |  | ) | const

inline

Get the ValueMap.

References _valueMap.

## getValueStack() [1/2]

ValueStack * osg::NodeVisitor::getValueStack | ( |  | ) |

inline

Get the ValueStack.

References _valueStack.

## getValueStack() [2/2]

const ValueStack * osg::NodeVisitor::getValueStack | ( |  | ) | const

inline

Get the const ValueStack.

References _valueStack.

## getViewPoint()

virtual osg::Vec3 osg::NodeVisitor::getViewPoint | ( |  | ) | const

inline virtual

Get the view point in local coordinates. Note, not all NodeVisitor implement this method, it is mainly cull visitors which will implement.

Reimplemented in osgUtil::CullVisitor.

References getEyePoint().

## getVisitorType()

VisitorType osg::NodeVisitor::getVisitorType | ( |  | ) | const

inline

Get the VisitorType.

References _visitorType.

Referenced by osgAnimation::UpdateUniform< T >::operator()().

## META_Object()

osg::NodeVisitor::META_Object | ( | osg | ,
|  | NodeVisitor | )

inline

Convert 'this' into a NodeVisitor pointer if Object is a NodeVisitor, otherwise return 0. Equivalent to dynamic_cast<NodeVisitor*>(this).

References asNodeVisitor(), and NodeVisitor().

## popFromNodePath()

void osg::NodeVisitor::popFromNodePath | ( |  | ) |

inline

Method called by osg::Node::accept() method after a call to NodeVisitor::apply(..). Note, the user does not typically call popFromNodePath() as it will be called automatically by the Node::accept() method.

References _nodePath, _traversalMode, and TRAVERSE_PARENTS.

Referenced by osgParticle::Emitter::accept(), osgParticle::ParticleEffect::accept(), osgParticle::ParticleProcessor::accept(), osgParticle::PrecipitationEffect::accept(), and osgParticle::Program::accept().

## pushOntoNodePath()

void osg::NodeVisitor::pushOntoNodePath | ( | Node * | node | ) |

inline

Method called by osg::Node::accept() method before a call to the NodeVisitor::apply(..). The back of the list will, therefore, be the current node being visited inside the apply(..), and the rest of the list will be the parental sequence of nodes from the top most node applied down the graph to the current node. Note, the user does not typically call pushNodeOnPath() as it will be called automatically by the Node::accept() method.

References _nodePath, _traversalMode, and TRAVERSE_PARENTS.

Referenced by osgParticle::Emitter::accept(), osgParticle::ParticleEffect::accept(), osgParticle::ParticleProcessor::accept(), osgParticle::PrecipitationEffect::accept(), and osgParticle::Program::accept().

## reset()

virtual void osg::NodeVisitor::reset | ( |  | ) |

inline virtual

Method to call to reset visitor. Useful if your visitor accumulates state during a traversal, and you plan to reuse the visitor. To flush that state for the next traversal: call reset() prior to each traversal.

Reimplemented in osg::CollectOccludersVisitor, osgAnimation::LinkVisitor, osgGA::EventVisitor, osgSim::InsertImpostorsVisitor, osgUtil::CullVisitor, osgUtil::GeometryCollector, osgUtil::IntersectionVisitor, osgUtil::Optimizer::FlattenBillboardVisitor, osgUtil::Optimizer::FlattenStaticTransformsDuplicatingSharedSubgraphsVisitor, osgUtil::Optimizer::StateVisitor, osgUtil::Optimizer::TextureAtlasVisitor, osgUtil::UpdateVisitor, and osgUtil::VertexCacheMissVisitor.

Referenced by osg::ComputeBoundsVisitor::META_NodeVisitor(), osgUtil::GLObjectsVisitor::META_NodeVisitor(), osgUtil::IntersectVisitor::META_NodeVisitor(), and osgUtil::StatsVisitor::META_NodeVisitor().

## setDatabaseRequestHandler()

void osg::NodeVisitor::setDatabaseRequestHandler | ( | DatabaseRequestHandler * | handler | ) |

inline

Set the handler for database requests.

References _databaseRequestHandler.

## setFrameStamp()

void osg::NodeVisitor::setFrameStamp | ( | FrameStamp * | fs | ) |

inline

Set the FrameStamp that this traversal is associated with.

References _frameStamp.

## setImageRequestHandler()

void osg::NodeVisitor::setImageRequestHandler | ( | ImageRequestHandler * | handler | ) |

inline

Set the handler for image requests.

References _imageRequestHandler.

## setNodeMaskOverride()

void osg::NodeVisitor::setNodeMaskOverride | ( | Node::NodeMask | mask | ) |

inline

Set the NodeMaskOverride mask. Used in validNodeMask() to determine whether to operate on a node or its subgraph, by OR'ing NodeVisitor::_nodeMaskOverride with the Node's own Node::_nodeMask. Typically used to force on nodes which may have been switched off by their own Node::_nodeMask.

References _nodeMaskOverride.

Referenced by osgUtil::BaseOptimizerVisitor::BaseOptimizerVisitor().

## setTraversalMask()

void osg::NodeVisitor::setTraversalMask | ( | Node::NodeMask | mask | ) |

inline

Set the TraversalMask of this NodeVisitor. The TraversalMask is used by the NodeVisitor::validNodeMask() method to determine whether to operate on a node and its subgraph. validNodeMask() is called automatically in the Node::accept() method before any call to NodeVisitor::apply(), apply() is only ever called if validNodeMask returns true. Note, if NodeVisitor::_traversalMask is 0 then all operations will be switched off for all nodes. Whereas setting both _traversalMask and _nodeMaskOverride to 0xffffffff will allow a visitor to work on all nodes regardless of their own Node::_nodeMask state.

References _traversalMask.

## setTraversalMode()

void osg::NodeVisitor::setTraversalMode | ( | TraversalMode | mode | ) |

inline

Set the traversal mode for Node::traverse() to use when deciding which children of a node to traverse. If a NodeVisitor has been attached via setTraverseVisitor() and the new mode is not TRAVERSE_VISITOR then the attached visitor is detached. Default mode is TRAVERSE_NONE.

References _traversalMode.

## setTraversalNumber()

void osg::NodeVisitor::setTraversalNumber | ( | unsigned int | fn | ) |

inline

Set the traversal number. Typically used to denote the frame count.

References _traversalNumber.

## setValueMap()

void osg::NodeVisitor::setValueMap | ( | ValueMap * | ps | ) |

inline

Set the ValueMap used to store Values that can be reused over a series of traversals.

References _valueMap.

## setValueStack()

void osg::NodeVisitor::setValueStack | ( | ValueStack * | ps | ) |

inline

Set the ValueStack used to stack Values during traversal.

References _valueStack.

## setVisitorType()

void osg::NodeVisitor::setVisitorType | ( | VisitorType | type | ) |

inline

Set the VisitorType, used to distinguish different visitors during traversal of the scene, typically used in the Node::traverse() method to select which behaviour to use for different types of traversal/visitors.

References _visitorType.

## traverse()

void osg::NodeVisitor::traverse | ( | Node & | node | ) |

inline

Method for handling traversal of a nodes. If you intend to use the visitor for actively traversing the scene graph then make sure the accept() methods call this method unless they handle traversal directly.

References _traversalMode, osg::Node::ascend(), osg::Node::traverse(), TRAVERSE_NONE, and TRAVERSE_PARENTS.

Referenced by osgAnimation::RigGeometry::FindNearestParentSkeleton::apply(), osgUtil::Optimizer::MergeGeometryVisitor::apply(), osgGA::EventVisitor::handle_callbacks_and_traverse(), osgUtil::UpdateVisitor::handle_callbacks_and_traverse(), osg::CollectOccludersVisitor::handle_cull_callbacks_and_traverse(), and osgUtil::CullVisitor::handle_cull_callbacks_and_traverse().

## validNodeMask()

bool osg::NodeVisitor::validNodeMask | ( | const osg::Node & | node | ) | const

inline

Method to called by Node and its subclass' Node::accept() method, if the result is true it is used to cull operations of nodes and their subgraphs. Return true if the result of a bit wise and of the NodeVisitor::_traversalMask with the bit or between NodeVistor::_nodeMaskOverride and the Node::_nodeMask. default values for _traversalMask is 0xffffffff, _nodeMaskOverride is 0x0, and osg::Node::_nodeMask is 0xffffffff.

References osg::Node::getNodeMask(), getNodeMaskOverride(), and getTraversalMask().

Referenced by osgParticle::Emitter::accept(), osgParticle::ParticleEffect::accept(), osgParticle::ParticleProcessor::accept(), osgParticle::PrecipitationEffect::accept(), and osgParticle::Program::accept().

## Member Data Documentation

## _databaseRequestHandler

ref_ptr<DatabaseRequestHandler> osg::NodeVisitor::_databaseRequestHandler

protected

Referenced by getDatabaseRequestHandler(), getDatabaseRequestHandler(), and setDatabaseRequestHandler().

## _frameStamp

ref_ptr<FrameStamp> osg::NodeVisitor::_frameStamp

protected

Referenced by getFrameStamp(), and setFrameStamp().

## _imageRequestHandler

ref_ptr<ImageRequestHandler> osg::NodeVisitor::_imageRequestHandler

protected

Referenced by getImageRequestHandler(), getImageRequestHandler(), and setImageRequestHandler().

## _nodeMaskOverride

Node::NodeMask osg::NodeVisitor::_nodeMaskOverride

protected

Referenced by getNodeMaskOverride(), and setNodeMaskOverride().

## _nodePath

NodePath osg::NodeVisitor::_nodePath

protected

Referenced by getNodePath(), getNodePath(), popFromNodePath(), and pushOntoNodePath().

## _traversalMask

Node::NodeMask osg::NodeVisitor::_traversalMask

protected

Referenced by getTraversalMask(), and setTraversalMask().

## _traversalMode

TraversalMode osg::NodeVisitor::_traversalMode

protected

Referenced by getTraversalMode(), popFromNodePath(), pushOntoNodePath(), setTraversalMode(), and traverse().

## _traversalNumber

unsigned int osg::NodeVisitor::_traversalNumber

protected

Referenced by getTraversalNumber(), and setTraversalNumber().

## _valueMap

osg::ref_ptr<ValueMap> osg::NodeVisitor::_valueMap

protected

Referenced by getOrCreateValueMap(), getValueMap(), getValueMap(), and setValueMap().

## _valueStack

osg::ref_ptr<ValueStack> osg::NodeVisitor::_valueStack

protected

Referenced by getOrCreateValueStack(), getValueStack(), getValueStack(), and setValueStack().

## _visitorType

VisitorType osg::NodeVisitor::_visitorType

protected

Referenced by getVisitorType(), and setVisitorType().

The documentation for this class was generated from the following file:

- NodeVisitor